Loading...
Searching...
No Matches
freecontact::predictor Class Reference

Protein residue contact predictor. More...

`#include <freecontact.h>`

## Public Types

typedef std::map< std::string, std::vector< contact_t > > | cont_res_t
typedef double | freq_t
typedef float | pairfreq_t
typedef std::vector< freq_t > | freq_vec_t
typedef std::map< std::string, double > | time_res_t

## Public Member Functions

| predictor (bool __dbg=false)
virtual | ~predictor ()
void | get_seq_weights (freq_vec_t &__aliw, double &__wtot, const ali_t &__ali, double __clustpc, bool __veczw=true, int __num_threads=0)
| Calculate alignment sequence weights.
cont_res_t | run (const ali_t &__ali, const freq_vec_t &__aliw, const double __wtot, double __density, double __gapth, uint16_t __mincontsep, double __pseudocnt, double __pscnt_weight, bool __estimate_ivcov, double __shrink_lambda, bool __cov20, bool __apply_gapth, double __rho, int __num_threads=0, time_t __icme_timeout=1800, time_res_t *__timing=NULL)
| Predict residue contacts.
cont_res_t | run (const ali_t &__ali, double __clustpc, double __density, double __gapth, uint16_t __mincontsep, double __pseudocnt, double __pscnt_weight, bool __estimate_ivcov, double __shrink_lambda, bool __cov20, bool __apply_gapth, double __rho, bool __veczw=true, int __num_threads=0, time_t __icme_timeout=1800, time_res_t *__timing=NULL)
| Predict residue contacts.
cont_res_t | run (const ali_t &__ali, const parset_t &__parset, bool __veczw=true, int __num_threads=0, time_t __icme_timeout=1800, time_res_t *__timing=NULL)
| Predict residue contacts.

## Public Attributes

bool | dbg

## Detailed Description

Protein residue contact predictor.

A sufficiently large multiple alignment is required for meaningful results.

Definition at line 160 of file freecontact.h.

## Member Typedef Documentation

## cont_res_t

typedef std::map<std::string, std::vector<contact_t> > freecontact::predictor::cont_res_t

Definition at line 162 of file freecontact.h.

## freq_t

typedef double freecontact::predictor::freq_t

Definition at line 163 of file freecontact.h.

## freq_vec_t

typedef std::vector<freq_t> freecontact::predictor::freq_vec_t

Definition at line 165 of file freecontact.h.

## pairfreq_t

typedef float freecontact::predictor::pairfreq_t

Definition at line 164 of file freecontact.h.

## time_res_t

typedef std::map<std::string, double> freecontact::predictor::time_res_t

Definition at line 166 of file freecontact.h.

## Constructor & Destructor Documentation

## predictor()

freecontact::predictor::predictor | ( | bool | __dbg = false | ) |

inline

Definition at line 169 of file freecontact.h.

## ~predictor()

virtual freecontact::predictor::~predictor | ( |  | ) |

inline virtual

Definition at line 170 of file freecontact.h.

## Member Function Documentation

## get_seq_weights()

void freecontact::predictor::get_seq_weights | ( | freq_vec_t & | __aliw,
|  | double & | __wtot,
|  | const ali_t & | __ali,
|  | double | __clustpc,
|  | bool | __veczw = true,
|  | int | __num_threads = 0 )

Calculate alignment sequence weights.

Parameters

  [out] | __aliw | Vector of alignment sequence weights.
  [out] | __wtot | Total alignment weight.
  [in] | __ali | Input alignment.
  [in] | __clustpc | BLOSUM-style clustering similarity threshold [0-1].
  [in] | __veczw | Use vectorized sequence weighting when available.
  [in] | __num_threads | Number of OpenMP threads, effective if non-zero. The default is as many threads as cores in host. Ineffective if library is not compiled with OMP support.

Definition at line 236 of file freecontact.cpp.

## run() [1/3]

predictor::cont_res_t freecontact::predictor::run | ( | const ali_t & | __ali,
|  | const freq_vec_t & | __aliw,
|  | const double | __wtot,
|  | double | __density,
|  | double | __gapth,
|  | uint16_t | __mincontsep,
|  | double | __pseudocnt,
|  | double | __pscnt_weight,
|  | bool | __estimate_ivcov,
|  | double | __shrink_lambda,
|  | bool | __cov20,
|  | bool | __apply_gapth,
|  | double | __rho,
|  | int | __num_threads = 0,
|  | time_t | __icme_timeout = 1800,
|  | time_res_t * | __timing = NULL )

Predict residue contacts.

Parameters

  [in] | __ali | Input alignment.
  [in] | __aliw | Vector of alignment sequence weights. Obtain this with get_seq_weights().
  [in] | __wtot | Total weight of alignment. Obtain this with get_seq_weights().
  [in] | __density | Target precision matrix density [0-1]. Set to 0 to not control density.
  [in] | __gapth | Threshold of weighted gap frequency for ignoring alignment columns with too many gaps [0-1]. Set to 1.00 to keep all columns. This is implemented by using a very high regularization value for gap columns, and by excluding gap columns from the covariance matrix, see __apply_gapth.
  [in] | __mincontsep | Minimum sequence-wise contacting residue pair separation given in amino acids as (j-i). 1 for adjacent residues. [1-).
  [in] | __pseudocnt | Number to initialize single and pair amino acid counts with [0-).
  [in] | __pscnt_weight | Pseudocount weight to apply to single and pair amino acid frequencies [0-1].
  [in] | __estimate_ivcov | Estimate inverse covariance matrix instead of fully inverting matrix. This is currently done by GLASSOFAST.
  [in] | __shrink_lambda | Covariance matrix shrinkage parameter, controlling rate of shrinkage [0-1].
  [in] | __cov20 | Leave one amino acid off the covariance matrix, making it non-overdetermined.
  [in] | __apply_gapth | When true, exclude residue columns and rows with a weighted gap frequency > __gapth from the covariance matrix.
  [in] | __rho | Initial value of Glasso regularization parameter. Negative values trigger an automatic choice for rho.
  [in] | __num_threads | Number of OpenMP threads, effective if non-zero. The default is as many threads as cores in host. Ineffective if library is not compiled with OMP support.
  [in] | __icme_timeout | Inverse covariance matrix estimation timeout in seconds. Default: 1800. Applied to each inversion call independently.
  [out] | __timing | Pointer to map of timing results for certain components of this method. Useful for debugging. Keys are: [num_threads|seqw|pairfreq|shrink|inv|all].

Returns
  Map of vectors of predicted contacts. Key is contact score calculation method name: 'l1norm', 'MI' (mutual information), 'fro' (Frobenius norm after zero-sum gauge). Vectors may not contain all contact pairs. Contacts are ordered by residue index (i,j).

Definition at line 434 of file freecontact.cpp.

## run() [2/3]

cont_res_t freecontact::predictor::run | ( | const ali_t & | __ali,
|  | const parset_t & | __parset,
|  | bool | __veczw = true,
|  | int | __num_threads = 0,
|  | time_t | __icme_timeout = 1800,
|  | time_res_t * | __timing = NULL )

inline

Predict residue contacts.

Definition at line 231 of file freecontact.h.

## run() [3/3]

predictor::cont_res_t freecontact::predictor::run | ( | const ali_t & | __ali,
|  | double | __clustpc,
|  | double | __density,
|  | double | __gapth,
|  | uint16_t | __mincontsep,
|  | double | __pseudocnt,
|  | double | __pscnt_weight,
|  | bool | __estimate_ivcov,
|  | double | __shrink_lambda,
|  | bool | __cov20,
|  | bool | __apply_gapth,
|  | double | __rho,
|  | bool | __veczw = true,
|  | int | __num_threads = 0,
|  | time_t | __icme_timeout = 1800,
|  | time_res_t * | __timing = NULL )

Predict residue contacts.

Definition at line 971 of file freecontact.cpp.

## Member Data Documentation

## dbg

bool freecontact::predictor::dbg

Definition at line 168 of file freecontact.h.

The documentation for this class was generated from the following files:

- freecontact.h
- freecontact.cpp